//+------------------------------------------------------------------+
//|                                           DoubleCCI-With_EMA.mq4 |

//+------------------------------------------------------------------+


#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 MediumSeaGreen
#property indicator_color2 Brown
#property indicator_color3 DimGray
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_color6 Silver
#property indicator_color7 Green

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 1

//#property indicator_width6 1
#property indicator_level1 200
#property indicator_level2 100
#property indicator_level3 100
#property indicator_level4 0
#property indicator_level5 0
#property indicator_level6 -100
#property indicator_level7 -100
#property indicator_level8 -200

#property indicator_levelcolor DarkSlateGray

//---- input parameters
extern string file="alert.wav";

extern int TrendCCI_period = 63;
extern int EntryCCI_period = 63;
extern bool Zero_cross_alert = true;
extern bool SMA_cross_alert = false;
extern int SMA_alert_delay = 1;
extern int Alert_level__Includes_negative = 0;
extern bool Show_SMA = true;
extern int SMA_period=55;
extern string SMA_of_TrendCCI_or_EntryCCI = "EntryCCI";
extern bool Automatic_timeframe_setting;
extern int M1_TrendCCI_period = 89;
extern int M1_EntryCCI_period = 21;
extern int M5_TrendCCI_period = 89;
extern int M5_EntryCCI_period = 21;
extern int M15_TrendCCI_period = 14;
extern int M15_EntryCCI_period = 6;
extern int M30_TrendCCI_period = 14;
extern int M30_EntryCCI_period = 6;
extern int H1_TrendCCI_period = 14;
extern int H1_EntryCCI_period = 6;
extern int H4_TrendCCI_period = 14;
extern int H4_EntryCCI_period = 6;
extern int D1_TrendCCI_period = 14;
extern int D1_EntryCCI_period = 6;
extern int W1_TrendCCI_period = 14;
extern int W1_EntryCCI_period = 6;
extern int MN_TrendCCI_period = 14;
extern int MN_EntryCCI_period = 6;
extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "cci Arrows1";
extern double arrowsUpperGap   = 1.0;
extern double arrowsLowerGap   = 1.0;
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Red;
extern int    arrowsUpCode     = 241;
extern int    arrowsDnCode     = 242;


double TrendCCIBuffer[];
double CCIHistogramUpBuffer[];
double CCIHistogramUpUpBuffer[];

double CCIHistogramDownBuffer[];
double CCIHistogramDownDownBuffer[];

double EntryCCIBuffer[];
double SMA[];
double trend[];
//double ZeroLine[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(8);
   SetIndexStyle (0, DRAW_HISTOGRAM, 0, 1);
   SetIndexBuffer(0, CCIHistogramUpBuffer);
   
   SetIndexStyle (1, DRAW_HISTOGRAM, 0, 1);
   SetIndexBuffer(1, CCIHistogramDownBuffer);
   
   SetIndexStyle (2, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(2, TrendCCIBuffer);
   
   SetIndexBuffer(5, SMA);
   SetIndexStyle (5, DRAW_LINE, STYLE_SOLID, 2);
   
   SetIndexStyle (6, DRAW_LINE, STYLE_SOLID, 1);
   SetIndexBuffer(6, EntryCCIBuffer);
        
   SetIndexStyle (3, DRAW_HISTOGRAM, 0, 2);
   SetIndexBuffer(3, CCIHistogramUpUpBuffer);
   
   SetIndexStyle (4, DRAW_HISTOGRAM, 0, 2);
   SetIndexBuffer(4, CCIHistogramDownDownBuffer);
   SetIndexBuffer(7, trend);
   
  
   
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   deleteArrows();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{

   int limit, trendCCI, entryCCI;
   static datetime prevtime = 0;
   int counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) counted_bars--;

   limit=Bars-counted_bars;
   
   if (Automatic_timeframe_setting == true) 
   {
      switch(Period()) 
      {
         case 1: trendCCI = M1_TrendCCI_period; entryCCI = M1_EntryCCI_period; break;
         case 5: trendCCI = M5_TrendCCI_period; entryCCI = M5_EntryCCI_period; break;
         case 15: trendCCI = M15_TrendCCI_period; entryCCI = M15_EntryCCI_period; break;
         case 30: trendCCI = M30_TrendCCI_period; entryCCI = M30_EntryCCI_period; break;
         case 60: trendCCI = H1_TrendCCI_period; entryCCI = H1_EntryCCI_period; break;
         case 240: trendCCI = H4_TrendCCI_period; entryCCI = H4_EntryCCI_period; break;
         case 1440: trendCCI = D1_TrendCCI_period; entryCCI = D1_EntryCCI_period; break;
         case 10080: trendCCI = W1_TrendCCI_period; entryCCI = W1_EntryCCI_period; break;
         case 43200: trendCCI = MN_TrendCCI_period; entryCCI = MN_EntryCCI_period; break;
      }
   }
   else 
   {
      trendCCI = TrendCCI_period;
      entryCCI = EntryCCI_period;
   }
      IndicatorShortName("(TrendCCI: " + trendCCI + ", EntryCCI: " + entryCCI + ") ");   
      for(int i = 0; i <= limit; i++) 
      {
        TrendCCIBuffer[i] = iCCI(NULL, 0, trendCCI, PRICE_TYPICAL, i);
      
      if (TrendCCIBuffer[i] >= 0 && TrendCCIBuffer[i] <= 100 )
         CCIHistogramUpBuffer[i] = TrendCCIBuffer[i];
      else
         CCIHistogramUpBuffer[i] = 0;
         
      if (TrendCCIBuffer[i] >= 100 )
         CCIHistogramUpUpBuffer[i] = TrendCCIBuffer[i];
      else
         CCIHistogramUpUpBuffer[i] = 0  ; 
    
      if (TrendCCIBuffer[i] < -100 )
         CCIHistogramDownDownBuffer[i] = TrendCCIBuffer[i];
      else
         CCIHistogramDownDownBuffer[i]=0;
         
      if (TrendCCIBuffer[i] < 0  && TrendCCIBuffer[i] >=-100)
         CCIHistogramDownBuffer[i] = TrendCCIBuffer[i];
      else
         CCIHistogramDownBuffer[i]=0;   
         
      
      EntryCCIBuffer[i] = iCCI(NULL, 0, entryCCI, PRICE_TYPICAL, i);
      
      
      //ZeroLine[i] = 0;      
      
   }
   if (Show_SMA == true) 
   {
      if (SMA_of_TrendCCI_or_EntryCCI == "TrendCCI")
         for(i=0; i<limit; i++)
            SMA[i] = iMAOnArray(TrendCCIBuffer, 0, SMA_period, 0, MODE_SMA, i);
      else if (SMA_of_TrendCCI_or_EntryCCI == "EntryCCI")
         for(i=0; i<limit; i++)
            SMA[i] = iMAOnArray(EntryCCIBuffer, 0, SMA_period, 0, MODE_SMA, i);
    }
    for (i=limit; i >= 0; i--)
    {
            trend[i] = trend[i+1];
            if (TrendCCIBuffer[i]>SMA[i]) trend[i] = 1;
            if (TrendCCIBuffer[i]<SMA[i]) trend[i] =-1;
            
            //
            //
            //
            //
            //
            
            if (ShowArrows)
            {
              deleteArrow(Time[i]);
              if (trend[i] != trend[i+1])
              {
                if (trend[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
                if (trend[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
              }
           }
   }         
   if (prevtime == Time[0]) {
         return(0);
   }
   
    
     
           if(EntryCCIBuffer[0] < -Alert_level__Includes_negative) {
            if((TrendCCIBuffer[0] < -Alert_level__Includes_negative) && (TrendCCIBuffer[1] >= -Alert_level__Includes_negative)) {
               {
               if (Zero_cross_alert == true)
                Alert(Symbol(), " M", Period(), " T&E CCI Sell");
                PlaySound(file);
               }
            }
         }
         else if(EntryCCIBuffer[0] > Alert_level__Includes_negative) {
            if((TrendCCIBuffer[0] > Alert_level__Includes_negative) && (TrendCCIBuffer[1] <= Alert_level__Includes_negative)) {
               { 
               if (Zero_cross_alert == true)
                Alert(Symbol(), " M", Period(), " T&E CCI Buy");
                PlaySound(file);
               }
            }
         }
  
   
    
        // Print("TrendCCIBuffer[2]="+TrendCCIBuffer[2]+" SMA[2]="+SMA[2]+" TrendCCIBuffer[1]="+TrendCCIBuffer[1]+" SMA[1]="+SMA[1]);
         if ((TrendCCIBuffer[SMA_alert_delay+1]>SMA[SMA_alert_delay+1]&&TrendCCIBuffer[SMA_alert_delay+0]<=SMA[SMA_alert_delay+0])
            ||(TrendCCIBuffer[SMA_alert_delay+1]<SMA[SMA_alert_delay+1]&&TrendCCIBuffer[SMA_alert_delay+0]>=SMA[SMA_alert_delay+0])) 
              {
               if (SMA_cross_alert == true)
                Alert(Symbol(), " M", Period(), " SMA & Trend CCI Have crossed");  
               PlaySound(file);
              }
   
   prevtime = Time[0];   
//----
   return(0);
  }
//+------------------------------------------------------------------+

//if (Zero_cross_alert == true)
//if (SMA_cross_alert == true)

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


